﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Routing;
using System.Web.Mvc;

namespace Kooboo.Web.Mvc.Grid
{
    public interface IGridActionVisibleArbiter
    {
        bool IsVisible(object dataItem, ViewContext viewContext);
    }
    public interface IGridActionRouteValuesGetter
    {
        RouteValueDictionary GetValues(object dataItem, RouteValueDictionary routeValueDictionary, ViewContext viewContext);
    }
    public class GridActionRouteValuesSetting
    {
        public string RouteValueName { get; set; }
        public string PropertyName { get; set; }
    }
    public class GridAction
    {
        public string ActionName { get; set; }
        public string ControllerName { get; set; }
        public string DisplayName { get; set; }
        public string ConfirmMessage { get; set; }

        public string VisibleProperty { get; set; }

        public IGridActionVisibleArbiter VisibleArbiter { get; set; }

        public IEnumerable<GridActionRouteValuesSetting> RouteValuesSetting { get; set; }
        public RouteValueDictionary RouteValues { get; set; }

        public IGridActionRouteValuesGetter RouteValuesGetter { get; set; }

    }
}
