﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Routing;
using System.Web.Mvc;

namespace Kooboo.Web.Mvc.Grid
{

    [AttributeUsage(AttributeTargets.Class, AllowMultiple = true)]
    public class GridActionAttribute : Attribute
    {
        public string ActionName { get; set; }
        public string ControllerName { get; set; }
        public string DisplayName { get; set; }
        public string ConfirmMessage { get; set; }
        /// <summary>
        /// Gets or sets the route value properties.
        /// <example>
        /// 1. "Name,Property2"
        /// 2. "Name=FullName" : "FullName" is the model property, "Name" is the alias for RouteValueName in RouteValueDictionary.
        /// </example>
        /// </summary>
        /// <value>The route value properties.</value>
        public string RouteValueProperties { get; set; }

        public string VisibleProperty { get; set; }
        /// <summary>
        /// A type of  
        /// </summary>
        /// <value>The visible arbiter.</value>
        public Type VisibleArbiter { get; set; }
        public Type RouteValuesGetter { get; set; }
        public int Order { get; set; }
        public override object TypeId
        {
            get
            {
                return this;
            }
        }
    }
}
